﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Blizzard.Contracts;
using Blizzard.Interceptors;

namespace Blizzard.Test.DataObjectsII
{
    [MapperAttribute(Table = "[DataObjectsII B]")]
   public class B : IDataObject
    {
        private Interceptor _interceptor;
        [MapperAttribute(Field = "[MY ID]", IsIdentityColumn = true)]
        public int Id { get; set; }

        private string _name;
        [Mapper(Field = "Name")]
        public string Name
        {
            get
            {
                _interceptor.Intercept(this, "Name", false);
                return _name;
            }
            set
            {
                _interceptor.Intercept(this, "Name", true, _name, value);
                _name = value;
            }
        }


        


        private A _a;
        [Mapper(Field = "[A ID]", Composition = true)]
        public A a
        {
            get 
            {
                _interceptor.Intercept(this, "a", false);
                return _a; 
            }
            set 
            {
                _interceptor.Intercept(this, "a", true, _a, value);
                _a = value; 
            }
        }


        private BList<C> cees;

        public BList<C> Cees
        {
            get 
            {
                _interceptor.Intercept(this, "Cees", false);
                return cees; 
            }
            set 
            {
                _interceptor.Intercept(this, "Cees", true, cees, value);
                cees = value; 
            }
        }


        
        private BList<BB> bBees;
        [Mapper(JoinTable = "[DataObjectsII B To BB]", MyIdField = "[B ID]")]
        public BList<BB> BBees
        {
            get 
            {
                _interceptor.Intercept(this, "BBees", false);
                return bBees; 
            }
            set 
            {
                _interceptor.Intercept(this, "BBees", true, bBees, value);
                bBees = value; 
            }
        }



       

        private BList<BBB> bBBees;
         [Mapper(JoinTable = "[DataObjectsII B To BBB]", MyIdField = "[B ID]")]
        public BList<BBB> BBBees
        {
            get 
            {
                _interceptor.Intercept(this, "BBBees", false);
                return bBBees; 
            }
            set 
            {
                _interceptor.Intercept(this, "BBBees", true, bBBees, value);
                bBBees = value; 
            }
        }



        public Container.BlizzardManager Manager
        {
            set { _interceptor = new Interceptor(value); }
        }
    }
}
