﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Blizzard.Container
{
    static class ProxyTypeContainer
    {

        private static Dictionary<Type, Type> innerContainer = new Dictionary<Type, Type>();

        internal static void ClearContainer()
        {
            innerContainer.Clear();
        }

        internal static void Add(Type proxyType)
        {
            Type baseType = proxyType;
            innerContainer.Add(baseType, proxyType);
        }

        internal static Type GetProxyType(Type baseType)
        {
            return innerContainer[baseType];
        }

        internal static bool HasProxyType(Type baseType)
        {
            return innerContainer.ContainsKey(baseType); 
        }
    }
}
